<?xml version="1.0" encoding="UTF-8"?>
<value type="metahash">
    <meta key="Editor" type="hash">
        <value key="Type" type="string">AcquisitionComponent</value>
        <value key="Component" type="string">control_cycle</value>
    </meta>

    <value key="Passive"/>
    <value key="Interface"/>

    <value key="EnableCycle" type="metaboolean">
        <meta key="Description" type="string">Enable the cycle on initialization</meta>
        <meta key="Editor" type="hash">
            <value key="Default" type="boolean">true</value>
        </meta>
    </value>
    <value key="LogActiveAction" type="metaboolean">
        <meta key="Description" type="string">Write logging values reflecting the currently active action</meta>
    </value>

    <value key="DefaultFlushTime" type="metareal">
        <meta key="Description" type="string">The default time to flush the system after executing any action</meta>
        <meta key="Format" type="string">0.0</meta>
        <meta key="Units" type="string">s</meta>
        <meta key="Editor" type="hash">
            <value key="Minimum" type="real">0.0</value>
            <value key="MinimumExclusive" type="boolean">true</value>
            <value key="AllowUndefined" type="boolean">true</value>
        </meta>
    </value>

    <value key="Period" merge="@/common/dynamictimeinterval.xml">
        <meta key="Description" type="string">The total period of the cycle</meta>
        <meta key="UndefinedDescription" type="string">One hour aligned</meta>
    </value>

    <value key="MinimumTime" merge="@/common/dynamictimeinterval.xml">
        <meta key="Description" type="string">The minimum amount of time to run the cycle for, before extending it to the next period</meta>
    </value>

    <value key="InitializeInactive" type="metaboolean">
        <meta key="Description" type="string">Initialize all actions in the cycle as already having been completed</meta>
    </value>

    <value key="SuspendOnBypass" type="metaboolean">
        <meta key="Description" type="string">Suspend cycle execution on system bypass</meta>
    </value>

    <value key="BaselineCommands" merge="@/acquisition/components/generic_command.xml">
        <meta key="Description" type="string">Base commands sent to all components for all actions</meta>
    </value>
    <value key="BaselineInstrumentCommands" merge="@/acquisition/components/generic_instrument_commands.xml">
        <meta key="Description" type="string">Base instrument command data for all actions, keyed by the instrument identifier (e.x. X1)</meta>
    </value>


    <value key="Spinup" type="metahash">
        <meta key="Description" type="string">Parameters for initial spin up of the cycle</meta>

        <value key="Duration" merge="@/common/dynamictimeinterval.xml">
            <meta key="Description" type="string">The total time the spin up is active for</meta>
        </value>

        <value key="Active" merge="@/acquisition/components/generic_action.xml">
            <meta key="Description" type="string">The action executed during the spin up phase</meta>
        </value>
        <value key="End" merge="@/acquisition/components/generic_action.xml">
            <meta key="Description" type="string">The action executed when the spin up phase ends</meta>
        </value>
    </value>

    <value key="End" merge="@/acquisition/components/generic_action.xml">
        <meta key="Description" type="string">The action executed when the spin up phase ends</meta>
    </value>

    <value key="Actions" type="metaarray">
        <meta key="Description" type="string">The defined cycle actions</meta>
        <meta key="Children" merge="@/acquisition/components/generic_action.xml">
            <meta key="Description" type="string">A single action within the cycle</meta>

            <meta key="Editor" type="hash">
                <value key="Type" type="string">TimeInterval</value>
                <value key="Composite" type="boolean">true</value>
                <value key="DefaultCollapsed" type="boolean">false</value>
            </meta>
            <value key="Units" merge="@/common/timeunits.xml"/>
            <value key="Count" type="metainteger">
                <meta key="Description" type="string">The number of units to apply in time</meta>
                <meta key="UndefinedDescription" type="string">0</meta>
                <meta key="Editor" type="hash">
                    <value key="AllowUndefined" type="boolean">false</value>
                </meta>
            </value>
            <value key="Align" type="metaboolean">
                <meta key="Description" type="string">Align units in logical time</meta>
            </value>

        </meta>
    </value>

</value>
